//
// $RCSfile: NativeFileInfo.cc,v $
// $Revision: 1.9 $
//
// Comments:
//
// (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
// The copyright notice above does not evidence any
// actual or intended publication of such source code.
//
// $Author: franczak $          $Locker:  $
// $Date: 2008-03-26 13:08:20 $
// $Log: not supported by cvs2svn $
// Revision 1.8  2007/02/02 15:31:14  mali
// fixing error name
//
// Revision 1.7  2007/02/02 15:25:00  mali
// add Native suffix for native methods
//
// Revision 1.6  2007/01/31 12:56:46  mali
// add error message
//
// Revision 1.5  2007/01/31 12:38:59  mali
// rename all error handling methods with 'get' prefix
//
// Revision 1.4  2007/01/31 12:33:18  mali
// error handling
//
// Revision 1.3  2007/01/31 08:15:00  mali
// use ErrorDescription
//
// Revision 1.2  2007/01/29 15:42:46  dario
// converting char* to java string
//
// Revision 1.1  2007/01/29 15:08:02  mali
// first version
//
//
#include "Common.h"
#include "NativeFileInfo.h"
#include "ErrorDescription.h"
#include <errno.h>

#include	<sys/types.h>
#include	<sys/stat.h> 

static ErrorDescription _error;

JNIEXPORT jlong JNICALL Java_com_parasoft_xtest_common_nativecode_NativeFileInfo_fileAccessTimeNative
  (JNIEnv* env, jclass clazz, jstring sFile)
{
    struct stat statData;
    int ret;

    _error.clearError();

    const char* cFile = env->GetStringUTFChars(sFile, 0);
    ret = stat(cFile, &statData);
    env->ReleaseStringUTFChars(sFile, cFile);

    if (ret >= 0) {
        long int atime = (long int)statData.st_atime;
        return atime;
    } else {
        _error.setError(errno, "stat", "Error during stat() function call!");
        return -1;
    }
}

JNIEXPORT jint JNICALL Java_com_parasoft_xtest_common_nativecode_NativeFileInfo_getErrorCodeNative
  (JNIEnv* env, jclass clazz)
{
    return _error.getErrorCode();
}

JNIEXPORT jstring JNICALL Java_com_parasoft_xtest_common_nativecode_NativeFileInfo_getErrorSourceNative
  (JNIEnv* env, jclass clazz)
{
    return env->NewStringUTF(_error.getErrorSource());
}

JNIEXPORT jstring JNICALL Java_com_parasoft_xtest_common_nativecode_NativeFileInfo_getErrorMessageNative
  (JNIEnv* env, jclass clazz)
{
    return env->NewStringUTF(_error.getErrorMessage());
}
