/*
 * $RCSfile: NativeMachineId.cc,v $
 * $Revision: 1.10 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1996.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: franczak $          $Locker:  $
 * $Date: 2008-03-26 13:08:20 $
 * $Log: not supported by cvs2svn $
 * Revision 1.9  2006/11/28 12:32:48  dario
 * errorMessage is now char* instead of string because of lib size
 *
 * Revision 1.8  2006/11/28 11:32:40  dario
 * errorMessage native method added
 *
 * Revision 1.7  2005/07/11 12:35:26  dario
 * solaris added
 *
 * Revision 1.6  2005/07/08 12:53:57  dario
 * signature changed
 *
 * Revision 1.5  2005/07/08 09:13:20  dario
 * linux code separated
 *
 * Revision 1.4  2005/07/08 08:29:17  dario
 * linux implementation: lsid added.
 *
 * Revision 1.3  2005/07/08 08:24:13  dario
 * linux includes added
 *
 * Revision 1.2  2005/07/08 07:44:35  dario
 * linux implementation added.
 *
 * Revision 1.1  2005/07/07 13:43:17  dario
 * added
 *
 */

#include "Common.h"
#include "NativeMachineId.h"

#include "MachineId.h"

#include <string.h>
char* _errorMessage;

JNIEXPORT jint JNICALL Java_com_parasoft_xtest_common_nativecode_NativeMachineId_machineId
  (JNIEnv *, jclass)
{
    MachineId machine;
    int id = machine.getMachineId();
    if (id & 0x80000000) {
       id = (id & 0x7fffffff) | 0x8000;
    }
    if (id == 0) {
       if (_errorMessage) {
           delete[] _errorMessage;
       }
       const char* error = machine.getErrorMessage();
       if (error) {
           _errorMessage = new char[strlen(error) + 1];
           strcpy(_errorMessage, error);
       }
    }
    return id;
}

JNIEXPORT jstring JNICALL Java_com_parasoft_xtest_common_nativecode_NativeMachineId_errorMessage
  (JNIEnv *env, jclass)
{
    return env->NewStringUTF((_errorMessage != 0) ? _errorMessage : "");
}
